%define ver	981103
Name: 		gnustep-core
Version: 	%{ver}
Release: 	1
Source: 	gnustep-core-%{ver}.tar.gz
Patch:	 	gnustep-core-981103-wraster.patch
Patch1:	 	gnustep-core-981103-make.patch
Copyright: 	LGPL/GPL
Group: 		Development
Summary: 	GNUstep core development package
Packager:	Red Hat Contrib|Net <rhcn-bugs@redhat.com>
Distribution:	Red Hat Contrib|Net
Vendor:		The Seawood Project <http://www.seawood.org/>
URL:		http://www.gnustep.org/
BuildRoot: 	/var/tmp/build-%{name}
%define prefix 	/usr
%define gsr 	%{prefix}/GNUstep
%define tlib	-lpthread
Conflicts: 	gnustep-base gnustep-extensions gnustep-gui gnustep-make gnustep-xraw

%description
   GNUstep is a set of general-purpose Objective-C libraries base on the
OpenStep standard developed by NeXT (now Apple) Inc. The libraries
consist of everything from foundation classes, such as dictionaries and
arrays, to GUI interface classes such as windows, sliders, buttons, etc.

This package is built with library-combo gnu-gnu-gnu-xraw.

%package -n gnustep-xdps
Summary: DPS GUI backend library
Group: Development
Requires: gnustep-core >= %{version}

%description -n gnustep-xdps
  The GNUstep GUI X/DPS Backend is for platforms using the X Window
System in combination with the Display Ghostscript System.  The Display
Ghostscript System is the free software GNU equivalent to the Display
PostScript System as specified by Adobe Systems Incorporated; it should
be possible to use `gnustep-xdps' with Adobe's DPS extensions to the X
Window System.

%changelog
* Wed Nov 04 1998 Christopher Seawood <cls@seawood.org>
- Added gnustep-xdps package to spec

* Tue Nov 03 1998 Christopher Seawood <cls@seawood.org>
- Grabbed snapshot from GNUstep CVS tree
- Used xraw backend instead of xdps
- Added RHCN tags

%prep
%setup -q -n %{name}-%{ver}
%patch -p1 -b .wraster
%patch1 -p1 -b .make
cp xraw/Source/wraster/wraster.h xraw/Headers/gnustep/xraw/
(cd make && autoconf)

%build
LIBS=%{tlib} CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%{gsr} --with-library-combo=gnu-gnu-gnu-xraw
make OPTFLAG=-g

rm -f xdps/Source/GNUmakefile.local
cp GNUmakefile.local xdps/Source/GNUmakefile.local
cd xdps
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%{gsr}
make OPTFLAG=-g library_combo=gnu-gnu-gnu-xdps GNUSTEP_MAKEFILES=`pwd`/../Makefiles GNUSTEP_SYSTEM_ROOT=%{gsr}

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p ${RPM_BUILD_ROOT}%{gsr}
mkdir -p ${RPM_BUILD_ROOT}/etc/profile.d
mkdir -p ${RPM_BUILD_ROOT}%{gsr}/Library/info
for i in 1 2 3 4 5 6 7 8; do
    mkdir -p ${RPM_BUILD_ROOT}%{gsr}/Library/man/man$i
done
mkdir -p ${RPM_BUILD_ROOT}%{gsr}/Libraries
mkdir -p ${RPM_BUILD_ROOT}%{gsr}/Local
for i in make base gui xraw extensions; do
    mkdir -p ${RPM_BUILD_ROOT}${RPM_DOC_DIR}/%{name}-%{ver}/$i
done
mkdir -p ${RPM_BUILD_ROOT}${RPM_DOC_DIR}/gnustep-xdps-%{ver}/

make install GNUSTEP_INSTALLATION_DIR=${RPM_BUILD_ROOT}%{gsr}
(cd xdps && make install library_combo=gnu-gnu-gnu-xdps GNUSTEP_MAKEFILES=`pwd`/../Makefiles GNUSTEP_SYSTEM_ROOT=%{gsr} GNUSTEP_INSTALLATION_DIR=${RPM_BUILD_ROOT}%{gsr} )

echo 'GMT' > ${RPM_BUILD_ROOT}%{gsr}/Libraries/Resources/gnustep/NSTimeZones/localtime

(cd base && tar -cBpzf examples.tar.gz examples )
for n in gui xraw xdps; do
   (cd $n && tar -cBpzf Testing.tar.gz Testing )
done

(cd base && cp -pr ANNOUNCE AUTHORS COPYING* ChangeLog* INSTALL* NEWS README* STATUS TODO examples.tar.gz Version ${RPM_BUILD_ROOT}${RPM_DOC_DIR}/%{name}-%{ver}/base/)

(cd extensions && cp -pr COPYING* ChangeLog NEWS README Version ${RPM_BUILD_ROOT}${RPM_DOC_DIR}/%{name}-%{ver}/extensions/)

(cd gui && cp -pr ANNOUNCE COPYING* ChangeLog* FAQ INSTALL NEWS README STATUS SUPPORT TODO Testing.tar.gz Version ${RPM_BUILD_ROOT}${RPM_DOC_DIR}/%{name}-%{ver}/gui/)

(cd make && cp -pr COPYING ChangeLog DESIGN README ${RPM_BUILD_ROOT}${RPM_DOC_DIR}/%{name}-%{ver}/make)

(cd xraw && cp -pr COPYING* FAQ INSTALL README SUPPORT TODO Testing.tar.gz Version ${RPM_BUILD_ROOT}${RPM_DOC_DIR}/%{name}-%{ver}/xraw)

cp -pr ANNOUNCE ChangeLog FAQ GNUstep-HOWTO INSTALL NEWS README Version  ${RPM_BUILD_ROOT}${RPM_DOC_DIR}/%{name}-%{ver}/

(cd xdps && cp -pr ANNOUNCE COPYING* ChangeLog FAQ INSTALL NEWS README STATUS SUPPORT TODO Testing.tar.gz Version ${RPM_BUILD_ROOT}${RPM_DOC_DIR}/gnustep-xdps-%{ver} )


%ifos Linux
# Create profile files
cat > mygnustep.sh << EOF
#!/bin/sh
. %{gsr}/Makefiles/GNUstep.sh
EOF

cat > mygnustep.csh << EOF
#!/bin/csh
source %{gsr}/Makefiles/GNUstep.csh
EOF

mv mygnustep.sh $RPM_BUILD_ROOT/etc/profile.d/GNUstep.sh
mv mygnustep.csh $RPM_BUILD_ROOT/etc/profile.d/GNUstep.csh
%endif

tmp1=`./make/config.guess`
tmp2=`./make/cpu.sh $tmp1`
tmp3=`./make/vendor.sh $tmp1`
tmp4=`./make/os.sh $tmp1`
tmp5=`./make/clean_cpu.sh $tmp2`
tmp6=`./make/clean_vendor.sh $tmp3`
tmp7=`./make/clean_os.sh $tmp4`

# Symlink libs into xdps libdir...except xraw
(cd  ${RPM_BUILD_ROOT}%{gsr}/Libraries/${tmp5}/${tmp7}/gnu-gnu-gnu-xdps &&\
	ln -s ../gnu-gnu-gnu-xraw/lib*.so* .)
rm -f ${RPM_BUILD_ROOT}%{gsr}/Libraries/${tmp5}/${tmp7}/gnu-gnu-gnu-xdps/libgnustep-xraw*

# Create filelist
cat > filelist.rpm.in << EOF
%defattr(-, root, root)
%docdir ${RPM_DOC_DIR}/%{name}-%{ver}
%config %{gsr}/share/config.site
%config %{gsr}/Makefiles/GSARCH/GSOS/config.make
%config %{gsr}/Libraries/Resources/gnustep/NSTimeZones/localtime
%ifos Linux
%config /etc/profile.d/GNUstep.csh
%config /etc/profile.d/GNUstep.sh
%endif

%dir %{gsr}
%dir %{gsr}/Apps
%dir %{gsr}/Headers
%dir %{gsr}/Headers/gnustep
%dir %{gsr}/Libraries
%dir %{gsr}/Libraries/Resources
%dir %{gsr}/Libraries/Resources/gnustep
%dir %{gsr}/Libraries/Resources/gnustep/NSTimeZones
%dir %{gsr}/Libraries/GSARCH
%dir %{gsr}/Libraries/GSARCH/GSOS
%dir %{gsr}/Local
%dir %{gsr}/Makefiles
%dir %{gsr}/Makefiles/GSARCH
%dir %{gsr}/Makefiles/GSARCH/GSOS
%dir %{gsr}/share

${RPM_DOC_DIR}/%{name}-%{ver}
%{gsr}/Headers/gnustep/Foundation
%{gsr}/Headers/gnustep/base
%{gsr}/Headers/gnustep/extensions
%{gsr}/Headers/gnustep/gui
%{gsr}/Headers/gnustep/unicode
%{gsr}/Headers/gnustep/xraw
%{gsr}/Headers/GSARCH
%{gsr}/Libraries/Resources/Images
%{gsr}/Libraries/Resources/gnustep/NSCharacterSets
%{gsr}/Libraries/Resources/gnustep/NSTimeZones/README
%{gsr}/Libraries/Resources/gnustep/NSTimeZones/abbreviations
%{gsr}/Libraries/Resources/gnustep/NSTimeZones/*.m
%{gsr}/Libraries/Resources/gnustep/NSTimeZones/regions
%{gsr}/Libraries/Resources/gnustep/NSTimeZones/zones
%{gsr}/Libraries/GSARCH/GSOS/gnu-gnu-gnu-xraw
%{gsr}/Library
%{gsr}/Makefiles/*.func
%{gsr}/Makefiles/*.make
%{gsr}/Makefiles/*.csh
%{gsr}/Makefiles/*.sh
%{gsr}/Makefiles/config*
%{gsr}/Makefiles/install-sh
%{gsr}/Makefiles/mkinstalldirs
%{gsr}/Makefiles/GSARCH/GSOS/which_lib
%{gsr}/Tools

EOF

# Create filelist-xdps
cat > filelist-xdps.rpm.in << EOF
%defattr(-, root, root)
%docdir ${RPM_DOC_DIR}/gnustep-xdps-%{ver}
${RPM_DOC_DIR}/gnustep-xdps-%{ver}
%{gsr}/Headers/gnustep/xdps
%{gsr}/Libraries/GSARCH/GSOS/gnu-gnu-gnu-xdps
EOF

for i in filelist.rpm filelist-xdps.rpm; do
    cat ${i}.in | sed "s|GSARCH|$tmp5|" | sed "s|GSOS|$tmp7|" > $i
done

%ifos Linux
%post
if [ -z "$GNUSTEP_SYSTEM_ROOT" ]; then
   . %{gsr}/Makefiles/GNUstep.sh 
fi
grep -q '%{gsr}/Libraries/$GNUSTEP_HOST_CPU/$GNUSTEP_HOST_OS/gnu-gnu-gnu-xraw' /etc/ld.so.conf || echo "%{gsr}/Libraries/$GNUSTEP_HOST_CPU/$GNUSTEP_HOST_OS/gnu-gnu-gnu-xraw" >> /etc/ld.so.conf
/sbin/ldconfig

%post -n gnustep-xdps
if [ -z "$GNUSTEP_SYSTEM_ROOT" ]; then
   . %{gsr}/Makefiles/GNUstep.sh 
fi
grep -q '%{gsr}/Libraries/$GNUSTEP_HOST_CPU/$GNUSTEP_HOST_OS/gnu-gnu-gnu-xdps' /etc/ld.so.conf || echo "%{gsr}/Libraries/$GNUSTEP_HOST_CPU/$GNUSTEP_HOST_OS/gnu-gnu-gnu-xdps" >> /etc/ld.so.conf
/sbin/ldconfig

%preun
if [ -z "$GNUSTEP_SYSTEM_ROOT" ]; then
   . %{gsr}/Makefiles/GNUstep.sh 
fi
mv -f /etc/ld.so.conf /etc/ld.so.conf.orig
grep -v "^%{gsr}/Libraries/$GNUSTEP_HOST_CPU/$GNUSTEP_HOST_OS/gnu-gnu-gnu-xraw$" /etc/ld.so.conf.orig > /etc/ld.so.conf
rm -f /etc/ld.so.conf.orig
/sbin/ldconfig

%preun -n gnustep-xdps
if [ -z "$GNUSTEP_SYSTEM_ROOT" ]; then
   . %{gsr}/Makefiles/GNUstep.sh 
fi
mv -f /etc/ld.so.conf /etc/ld.so.conf.orig
grep -v "^%{gsr}/Libraries/$GNUSTEP_HOST_CPU/$GNUSTEP_HOST_OS/gnu-gnu-gnu-xdps$" /etc/ld.so.conf.orig > /etc/ld.so.conf
rm -f /etc/ld.so.conf.orig
/sbin/ldconfig

%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files -f filelist.rpm

%files -n gnustep-xdps -f filelist-xdps.rpm

